Index: cpukit/ChangeLog
===================================================================
--- cpukit/ChangeLog	(revision 7ea5560702be29573e4b1b1cf14f07cd5147a2b8)
+++ cpukit/ChangeLog	(revision faf45cca28549fba8ac7dc68d3f614d6a7d2543d)
@@ -1,2 +1,9 @@
+2004-01-21	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* aclocal/rtems-top.m4: Remove PROJECT_ROOT.
+	Prepend ../ to $1.
+	* aclocal/env-rtemscpu.m4: Reworked.
+	* configure.ac: RTEMS_TOP([.]).
+
 2004-01-19	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
 
Index: cpukit/aclocal/env-rtemscpu.m4
===================================================================
--- cpukit/aclocal/env-rtemscpu.m4	(revision 7ea5560702be29573e4b1b1cf14f07cd5147a2b8)
+++ cpukit/aclocal/env-rtemscpu.m4	(revision faf45cca28549fba8ac7dc68d3f614d6a7d2543d)
@@ -1,25 +1,17 @@
 dnl $Id$
 
+# PROJECT_ROOT .. Directory to put the temporary installed files into
+
+# FIXME: to be revisited - featureladden, bloated 
 AC_DEFUN([RTEMS_ENV_RTEMSCPU],
 [
   AC_REQUIRE([RTEMS_ENABLE_MULTILIB])
 
-  AS_IF([test x"$multilib" = x"yes"],
-  [
-    AS_IF([test -n "$with_multisubdir"],
-      [MULTIBUILDTOP=`echo "/$with_multisubdir" | sed 's,/[[^\\/]]*,../,g'`])
-    AC_SUBST(MULTIBUILDTOP)
- 
-    AS_IF([test -n "$with_multisubdir"],
-      [MULTISUBDIR="/$with_multisubdir"])
-    AC_SUBST(MULTISUBDIR)
- 
-    AC_SUBST([PROJECT_INCLUDE],["${PROJECT_ROOT}/lib/include"])
-    AC_SUBST([PROJECT_LIB],["${PROJECT_ROOT}/lib\$(MULTISUBDIR)"])
+  # RTEMS_TOPdir points to the top of RTEMS source tree
+  # cpukit_topdir points to the top of the cpukit source tree
+  cpukit_topdir="/${RTEMS_TOPdir}/"
 
-    includedir="\${exec_prefix}/include"
-    libdir="${libdir}\$(MULTISUBDIR)"
-  ],
-  [
+  AS_IF([test -n "$enable_rtemsbsp"],
+  [ # Per BSP
     AC_ARG_VAR([CPU_CFLAGS],[])
     AC_ARG_VAR([CFLAGS_OPTIMIZE_V],
@@ -28,8 +20,7 @@
       [CFLAGS for building the debugging variant])
  
-    AC_ARG_VAR([RTEMS_BSP],[RTEMS_BSP to build])
     AC_MSG_CHECKING([for RTEMS_BSP])
     AC_CACHE_VAL(rtems_cv_RTEMS_BSP,[
-      test -n "${RTEMS_BSP}" && rtems_cv_RTEMS_BSP="$RTEMS_BSP"
+      test -n "${RTEMS_BSP}" && rtems_cv_RTEMS_BSP="$enable_rtemsbsp"
     ])
     AS_IF([test -z "$rtems_cv_RTEMS_BSP"],[
@@ -38,10 +29,48 @@
     RTEMS_BSP="$rtems_cv_RTEMS_BSP"
     AC_MSG_RESULT(${RTEMS_BSP})
- 
+
+    test x"${with_project_root}" = x && with_project_root=".";
+    case x${with_project_root} in
+    x[[\\/]]* | x?:[[\\/]]* ) # absolute dir
+      PROJECT_ROOT="${with_project_root}"
+      ;;
+    x* ) # relative dir
+      PROJECT_ROOT="\$(top_builddir)${cpukit_topdir}${with_project_root}"
+      ;;
+    esac
+
+    PROJECT_ROOT="${PROJECT_ROOT}/$RTEMS_BSP"
+    AC_SUBST([PROJECT_INCLUDE],["${PROJECT_ROOT}/lib/include"])
+    AC_SUBST([PROJECT_LIB],["${PROJECT_ROOT}/lib"])
+
     includedir="\${exec_prefix}/${RTEMS_BSP}/lib/include"
     libdir="\${exec_prefix}/${RTEMS_BSP}/lib"
+  ],[
+    AS_IF([test x"$multilib" = x"yes"],
+    [
+      AS_IF([test -n "$with_multisubdir"],
+        [MULTIBUILDTOP=`echo "/$with_multisubdir" | sed 's,/[[^\\/]]*,../,g'`])
+      AC_SUBST(MULTIBUILDTOP)
+ 
+      AS_IF([test -n "$with_multisubdir"],
+        [MULTISUBDIR="/$with_multisubdir"])
+      AC_SUBST(MULTISUBDIR)
 
-    AC_SUBST([PROJECT_INCLUDE],["${PROJECT_ROOT}/$RTEMS_BSP/lib/include"])
-    AC_SUBST([PROJECT_LIB],["${PROJECT_ROOT}/$RTEMS_BSP/lib"])
+      PROJECT_ROOT="\$(top_builddir)${cpukit_topdir}../\$(MULTIBUILDTOP)"
+
+      AC_SUBST([PROJECT_INCLUDE],["${PROJECT_ROOT}lib/include"])
+      AC_SUBST([PROJECT_LIB],["${PROJECT_ROOT}lib\$(MULTISUBDIR)"])
+
+      includedir="\${exec_prefix}/include"
+      libdir="${libdir}\$(MULTISUBDIR)"
+    ],[
+      PROJECT_ROOT="\$(top_builddir)${cpukit_topdir}"
+
+      AC_SUBST([PROJECT_INCLUDE],["${PROJECT_ROOT}lib/include"])
+      AC_SUBST([PROJECT_LIB],["${PROJECT_ROOT}lib\$(MULTISUBDIR)"])
+
+      includedir="\${exec_prefix}/include"
+      libdir="${libdir}\$(MULTISUBDIR)"
+    ])
   ])
 
@@ -49,4 +78,6 @@
   AC_SUBST([project_includedir],["\$(includedir)"])
 
+  AC_SUBST(PROJECT_ROOT)
+
   AM_CONDITIONAL([MULTILIB],[test x"$multilib" = x"yes"])
 ])
Index: cpukit/aclocal/rtems-top.m4
===================================================================
--- cpukit/aclocal/rtems-top.m4	(revision 7ea5560702be29573e4b1b1cf14f07cd5147a2b8)
+++ cpukit/aclocal/rtems-top.m4	(revision faf45cca28549fba8ac7dc68d3f614d6a7d2543d)
@@ -6,5 +6,5 @@
 dnl RTEMS_TOP($1)
 dnl 
-dnl $1 .. relative path from this configure.in to the toplevel configure.in
+dnl $1 .. relative path from this configure.ac to the toplevel configure.ac
 dnl
 AC_DEFUN([RTEMS_TOP],
@@ -12,5 +12,5 @@
 AC_REQUIRE([RTEMS_VERSIONING])
 AC_REQUIRE([AM_SET_LEADING_DOT])
-AC_CONFIG_AUX_DIR([$1])
+AC_CONFIG_AUX_DIR([../$1])
 AC_CHECK_PROGS(MAKE, gmake make)
 AC_BEFORE([$0], [AM_INIT_AUTOMAKE])dnl
@@ -24,6 +24,4 @@
 test -n "$with_target_subdir" || with_target_subdir="."
 
-PROJECT_ROOT="${with_project_root}${RTEMS_TOPdir}/\$(MULTIBUILDTOP)\$(top_builddir)"
-
 AC_MSG_CHECKING([for RTEMS Version])
 AC_MSG_RESULT([_RTEMS_VERSION])
Index: cpukit/configure.ac
===================================================================
--- cpukit/configure.ac	(revision 7ea5560702be29573e4b1b1cf14f07cd5147a2b8)
+++ cpukit/configure.ac	(revision faf45cca28549fba8ac7dc68d3f614d6a7d2543d)
@@ -6,5 +6,5 @@
 AC_INIT([rtems-cpukit],[_RTEMS_VERSION],[rtems-bugs@rtems.com])
 AC_CONFIG_SRCDIR([score])
-RTEMS_TOP(..)
+RTEMS_TOP([.])
 
 RTEMS_CANONICAL_TARGET_CPU
